import { VariantLabels } from "../motion/types";
import { VisualElementAnimationControls } from "./VisualElementAnimationControls";
/**
 * Handle variants and the `animate` prop when its set as variant labels.
 *
 * @param initial - Initial variant(s)
 * @param animate - Variant(s) to animate to
 * @param inherit - `true` is inheriting animations from parent
 * @param controls - Animation controls
 *
 * @internal
 */
export declare function useVariants(initial: VariantLabels, animate: VariantLabels, inherit: boolean, controls: VisualElementAnimationControls): void;
